/* 
 * PosixRealTimeExecutionContext.h
 * Masaharu Shimizu@fuRo
 * 08/9/1 
 *
 */

#ifndef PosixRealTimeExecutionContext_h
#define PosixRealTimeExecutionContext_h

#include <rtm/RTC.h>

#include <ace/Task.h>
#include <ace/Synch.h>

#include <rtm/Manager.h>
#include <rtm/PeriodicExecutionContext.h>

#include <malloc.h> 
#include <sys/mman.h>
#include <time.h>
#include <unistd.h>
#include <pthread.h>

#define NSEC_PER_SEC 1000000000L

namespace RTC
{
  class PosixRealTimeExecutionContext
    : public virtual PeriodicExecutionContext
  {
  public:
	  PosixRealTimeExecutionContext();
	  virtual ~PosixRealTimeExecutionContext();
	  virtual int svc(void);
  private:
	  void timespec_add_ns(struct timespec *a, unsigned int ns);
	  int timespec_compare(const struct timespec *lhs, const timespec *rhs);
  };
};

extern "C"
{
  void PosixRealTimeExecutionContextInit(RTC::Manager* manager);
};

#endif // PosixRealTimeExecutionContext_h

